QGIS Application - Bug report #12392
QgsRubberBand not fully refreshing
2015-03-17 09:14 AM - Anatoliy Golubev

Status: Closed

Priority: Normal

Assignee: Sandro Santilli

Category: Map Canvas

Affected QGIS version:2.8.1 Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 20566
Description

QgsRubberBand items sometimes not refreshing properly when another map
canvas item (QgsVertexMarker) intersects them. This happens with 2.8,
in 2.6.1 works as expected.

See: https://www.dropbox.com/s/4egl61juue9ewop/rubberband.png?dI=0 as

illustration

How to reproduce:
1. Open empty project (epsg:4326)
2. Execute this script in python console:

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.gui import *

from qgis.core import *

mCursor = QgsVertexMarker(iface.mapCanvas())
mCursor.setlconType(QgsVertexMarker.ICON_BOX)
mCursor.setlconSize(20)

mCursor.setZValue(5)

points = [[QgsPoint(0, 0), QgsPoint(20, 30), QgsPoint(0, 60)]]
rb = QgsRubberBand(iface.mapCanvas(), True)
rb.setToGeometry(QgsGeometry.fromPolygon(points), None)
rb.setColor(QColor(125, 125, 0))

rb.show()

def changeCursorPos(p):
mCursor.setCenter(p)

iface.mapCanvas().xyCoordinates.connect(changeCursorPos)

3. Move mouse cursor over rubber band.
You can erase rubber band from bottom to some upper point.

Tested on win7 32bit
https://www.dropbox.com/s/4egl61juue9ewop/rubberband.png?dl=0

Associated revisions

Revision a844bfa1 - 2015-04-01 12:25 PM - Sandro Santilli
Recompute rubberband extent on zoom/pan

Fix #12392

Includes testcase

Revision 37171dc0 - 2015-04-01 12:30 PM - Sandro Santilli
Fix QgsRubberBand refresh

- Fixes invalid calculation of rubberband boundingRect

- Scales icon and pen width with rubberband when computing rect

- Recompute rubberband extent on zoom/pan

Fix #12392

Includes testcase

(backport of master commits d43d8bf 84d47c9 a844bfa)

History

#1 - 2015-03-17 09:20 AM - Anatoliy Golubev

ups...code should be:
points = [ [QgsPoint(0, 0), QgsPoint(20, 30), QgsPoint(0, 60)] ]

#2 - 2015-03-25 01:59 AM - Anatoliy Golubev
- Assignee set to Sandro Santilli

| found that this bug was introduced in commit:d7269595

Sandro, can you look at it?

#3 - 2015-03-25 02:35 AM - Sandro Santilli

it looks like it's failing to update the lower and right sides.
Your script did not work here: TypeError: QgsGeometry.fromPolygon(unknown-type): argument 1 has unexpected type 'tuple’

Any way to reproduce this with some core tool ?

Or (even better), could you provide an automated test to include in the suite ?

#4 - 2015-03-25 02:48 AM - Anatoliy Golubev

This script works fine in 2.8.1 (redmine eat double brackets)
from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.gui import *

from qgis.core import *

mCursor = QgsVertexMarker(iface.mapCanvas())
mCursor.setlconType(QgsVertexMarker.ICON_BOX)
mCursor.setlconSize(20)

mCursor.setZValue(5)

points = [ [QgsPoint(0, 0), QgsPoint(20, 30), QgsPoint(0, 60)] ]
rb = QgsRubberBand(iface.mapCanvas(), True)
rb.setToGeometry(QgsGeometry.fromPolygon(points), None)
rb.setColor(QColor(125, 125, 0))

rb.show()

def changeCursorPos(p):
mCursor.setCenter(p)

iface.mapCanvas().xyCoordinates.connect(changeCursorPos)

#5 - 2015-03-25 03:45 AM - Sandro Santilli
iface.mapCanvas().xyCoordinates.connect(changeCursorPos)
File "<input>", line 4

iface.mapCanvas().xyCoordinates.connect(changeCursorPos)

A

SyntaxError: invalid syntax

#6 - 2015-03-25 05:27 AM - Anatoliy Golubev
- File rubberband2.png added

| get this syntax error when there are some spaces between "mCursor.setCenter(p) and iface. iface should not be in changeCursorPos function.

You can try copy all code except last line, and then copy last line.

See attached screenshot

#7 - 2015-03-25 11:33 AM - Sandro Santilli

Got it, | need to enter an additional empty line to signal end of "changeCursorPos" function (in the python console) -- trying

#8 - 2015-03-25 01:10 PM - Nyall Dawson
Sandro - you probably need to override the boundingRect method in QgsRubberBand to return the correct rubber band bounds. It would seem the base

implementation of this method is returning a rect which is too small for the rubber band. That would account for this behaviour...

#9 - 2015-03-26 02:05 AM - Sandro Santilli

| actually wonder if QgsMapCanvasltem::boundingRect is correct, in that it assumes the bounding rectangle always starts at the upper-left corner. Reading

the code it looks like "mltemSize" should be correct (it's set by QgsMapCanvasltem::setRect) but boundingRect does not take mRect in consideration at

all!

#10 - 2015-03-27 10:18 AM - Sandro Santilli

I've added debugging output in 2.6 and 2.8 branches to see what's going on.

First of all I noticed that even with an empty project, the QgsRubberBand::boundingRect (I added an override there, just for the sake of printing a

debugging output) gets called for every pan and zoom.

Second, with the python code above, moving the rubberband around the canvas does not change the returned "boundingRect" which seems to only

depend on scale. | continue to think it's always been bogus somehow...

#11 - 2015-03-27 10:20 AM - Sandro Santilli

Oops, sorry, only now | realize that the "rubberband" in the test is the triangle, not the cursor. It makes sense for it to not change when moving the cursor.

Looking better now :)

#12 - 2015-03-27 10:25 AM - Sandro Santilli

Ok now | confirm that no matter where | pan (moving the rubberband triangle around the screen) the boundingRect (with 2.6) always reports the same
value, which is only dependent on zoom/size-of-rubberband, and always starts with -1,-1.

For example

at scale 1:140,273,942:

src/gui/ggsrubberband.cpp: 522: (boundingRect) XXX rect is -1.0000000000000000,-1.0000000000000000 :

45.7176168480304597,135.0688211983073757

#13 - 2015-03-27 11:33 AM - Sandro Santilli

Alright one difference is that while in 2.6 the rectangle size updates with scale, in master it seems to be fixed.

updateRect is called once at rubberband creation time in both cases. Dunno what else is supposed to change mltemSize

#14 - 2015-03-27 11:37 AM - Sandro Santilli

QgsMapCanvasltem::updatePosition calls setRect again in 2.6. In master ggsrubberband overrides updatePosition to do nothing, thus the mltemSize does

not change.

#15 - 2015-03-27 11:45 AM - Anatoliy Golubev

QgsRubberBand::updateRect calls QgsMapCanvasltem::setRect too
// This is an hack to pass QgsMapCanvasltem::setRect what it

/1 expects (encoding of position and size of the item)

QgsPoint topLeft = m2p.toMapPoint( r.xMinimum(), r.yMinimum() ); <-

double res = m2p.mapUnitsPerPixel();

QgsRectangle rect( topLeft.x(), topLeft.y(), topLeft.x() + r.width()*res, topLeft.y() - r.height()*res ); <-

Maybe thats the point? Why should we subtract r.height()*res from r.yMinimum()?

#16 - 2015-03-27 11:49 AM - Sandro Santilli

updateRect call to setRect is ok, | think.

| confirm dropping the override fixes this bug. But it's to be checked what else (if anything) breaks.

| think it's better to have an automated test for this bug before fixing it. If not else if any other breackage comes out the fix for that won't re-introduce this.

Do you think you can provide an automated test for this, Anatoliy ?

#17 - 2015-03-27 11:55 AM - Anatoliy Golubev

Dont know how to automate it, sorry.

#18 - 2015-03-27 11:56 AM - Sandro Santilli

Theres a tests/src/gui/testqgsrubberband.cpp file you could start from

#19 - 2015-03-27 12:24 PM - Anatoliy Golubev

Ok, Im look at it

#20 - 2015-03-28 02:36 AM - Sandro Santilli

A fix is available here: https://github.com/qgis/QGIS/pull/1968

Adding your test there would be useful, before merging.

#21 - 2015-04-01 01:15 AM - Sandro Santilli
- Target version set to Version 2.8.2
- % Done changed from 0 to 90

#22 - 2015-04-01 01:16 AM - Sandro Santilli
- Pull Request or Patch supplied changed from No to Yes

#23 - 2015-04-01 03:26 AM - Sandro Santilli
- Status changed from Open to Closed
https://github.com/qgis/QGIS/pull/1968

Fixed in changeset commit:"a844bfa17490391bcfac54700ace76afbeac90f0".

#24 - 2015-04-01 03:32 AM - Sandro Santilli
- Status changed from Closed to Reopened

reopened as the fix needs to be backported to 2.8 branch

#25 - 2015-04-01 03:57 AM - Sandro Santilli
- Tag set to rotation

Also, I'd like a confirmation from the reporter about effectiveness of the fix (currently in master)

#26 - 2015-04-01 04:51 AM - Anatoliy Golubev

Tested master on debian, it seems ok, refreshing works fine.

#27 - 2015-04-01 07:40 AM - Sandro Santilli
- Status changed from Reopened to Closed

Fixed in changeset commit:"37171dc0b780bae69989aced4544e51d11ceefba".

Files
rubberband2.png 167 KB 2015-03-25 Anatoliy Golubev
